# Installation

o80 has been tested exclusively on ubuntu 20.04 and ubuntu 18.04.

## From binaries

o80's binaries are available only for ubuntu18.04/python3.6 and ubuntu20.04/python3.8.

To install, first select a version by visiting : [http://people.tuebingen.mpg.de/mpi-is-software/o80/latest/](http://people.tuebingen.mpg.de/mpi-is-software/o80/latest/) or [http://people.tuebingen.mpg.de/mpi-is-software/o80/older/](http://people.tuebingen.mpg.de/mpi-is-software/o80/older/). Then, for example:

```bash
wget http://people.tuebingen.mpg.de/mpi-is-software/o80/latest/o80_ubuntu20.04_py3.8_1.0.tar.gz
tar -zxvf ./o80_ubuntu20.04_py3.8_1.0.tar.gz
sudo ./apt_dependencies
sudo ./pip3_dependencies
./configure
sudo make install
sudo ldconfig
```

## From source

### From tar ball

Select a version by visiting : [http://people.tuebingen.mpg.de/mpi-is-software/o80/latest/](http://people.tuebingen.mpg.de/mpi-is-software/o80/latest/) or [http://people.tuebingen.mpg.de/mpi-is-software/o80/older/](http://people.tuebingen.mpg.de/mpi-is-software/o80/older/). Then, for example:

```bash
wget http://people.tuebingen.mpg.de/mpi-is-software/o80/latest/o80_source.tar.gz
tar -zxvf ./o80_source.tar.gz
sudo ./apt-dependencies
sudo ./pip3-dependencies
./configure
make
sudo make install
sudo ldconfig
```

### Via colcon workspace

[Colcon](https://colcon.readthedocs.io/en/released/) is the built system of [ROS2](https://docs.ros.org/en/foxy/index.html).
The instructions below will result in the setup of a colcon workspace. Possibly, if you would like to use o80 in a ROS2 project, you may copy the cloned packages to an existing workspace.

#### Adding your ssh key to github

See: [github documentation](https://help.github.com/en/github/authenticating-to-github/connecting-to-github-with-ssh).

All the following instructions assume your ssh key has been activated, i.e.:

```bash
# replace id_rsa by your key file name
ssh-add ~/.ssh/id_rsa
```

#### Installing the dependencies:

```bash
apt install -y python3-pip cmake libcereal-dev \
               libboost-all-dev libgtest-dev \
	       libeigen3-dev libedit-dev \
	       libncurses5-dev freeglut3-dev \
	       libxmu-dev doxygen
```

```bash
pip3 install colcon-common-extensions treep \
             fyplot pyside2 empy \
	     catkin-pkg sphinx breathe
```

#### Cloning the repositories

Creating a folder and cloning the treep configuration:

```bash
mkdir Software # you may use another folder name
cd Software
git clone git@github.com:intelligent-soft-robots/treep_isr.git
```

Cloning all the required repositories:

```bash
treep --clone O80
```

#### Compilation

```bash
cd /path/to/Software
cd workspace
colcon build
```

This will result in a "install" folder containing the compiled binaries

### Activating the workspace

In each new terminal, the workspace needs to be sourced:

```bash
source /path/to/Software/install/setup.bash
```

Possibly, you may want to add the line above to the ~/.bashrc file (so that each new terminal source the workspace automatically).


## Checking installation

In a python3 terminal:

```python
import o80
```